Package org.apache.cayenne.exp.property

# Interface ComparableProperty<E>

All Superinterfaces:
  `Property<E>`

All Known Implementing Classes:
  `DateProperty`, `NumericIdProperty`, `NumericProperty`, `Property`, `StringProperty`

public interface ComparableProperty<E> extends Property<E>
Interface (or "Trait") that provides basic functionality for comparable properties.

Since:
  4.2
See Also:
  - `org.apache.cayenne.exp.property`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default Expression`
  `between(E lower, E upper)`
  `default Expression`
  `between(ComparableProperty<?> lower, ComparableProperty<?> upper)`
  `default Expression`
  `gt(E value)`
  `default Expression`
  `gt(ComparableProperty<?> value)`
  `default Expression`
  `gte(E value)`
  `default Expression`
  `gte(ComparableProperty<?> value)`
  `default Expression`
  `lt(E value)`
  `default Expression`
  `lt(ComparableProperty<?> value)`
  `default Expression`
  `lte(E value)`
  `default Expression`
  `lte(ComparableProperty<?> value)`
  `default BaseProperty<E>`
  `max()`
  `default BaseProperty<E>`
  `min()`

  ### Methods inherited from interface org.apache.cayenne.exp.property.Property

  `getAlias, getExpression, getName, getType`

- ## Method Details

  - ### between

    default Expression between(E lower, E upper)
    Parameters:
      `lower` - The lower bound.
      `upper` - The upper bound.
    Returns:
      An expression checking for objects between a lower and upper bound inclusive

  - ### between

    default Expression between(ComparableProperty<?> lower, ComparableProperty<?> upper)
    Parameters:
      `lower` - The lower bound.
      `upper` - The upper bound.
    Returns:
      An expression checking for objects between a lower and upper bound inclusive

  - ### gt

    default Expression gt(E value)
    Returns:
      A greater than Expression.

  - ### gt

    default Expression gt(ComparableProperty<?> value)
    Returns:
      Represents a greater than relationship between two attributes (columns).

  - ### gte

    default Expression gte(E value)
    Returns:
      A greater than or equal to Expression.

  - ### gte

    default Expression gte(ComparableProperty<?> value)
    Returns:
      Represents a greater than or equal relationship between two attributes (columns).

  - ### lt

    default Expression lt(E value)
    Returns:
      A less than Expression.

  - ### lt

    default Expression lt(ComparableProperty<?> value)
    Returns:
      Represents a less than relationship between two attributes (columns).

  - ### lte

    default Expression lte(E value)
    Returns:
      A less than or equal to Expression.

  - ### lte

    default Expression lte(ComparableProperty<?> value)
    Returns:
      Represents a less than or equal relationship between two attributes (columns).

  - ### max

    default BaseProperty<E> max()
    See Also:
      - `FunctionExpressionFactory.maxExp(Expression)`

  - ### min

    default BaseProperty<E> min()
    See Also:
      - `FunctionExpressionFactory.minExp(Expression)`